<?
//phpinfo();
//exit();
//
// GiftWeb: PHP/PostgreSQL online Gift Registry System 
// Matthew T. Jachimstal
// Copyright (C) 2000  Matthew T. Jachimstal
//
// email: matthew@jachimstal.com
//
// Snail mail: Matthew Jachimstal
//             337 Chesterfield Lane, #205
//             Maumee, OH 43537
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//

require "./main.inc";
require "./util.php";

$uid = validatesession($s);
$conn = pg_connect($dbhost, $dbport, $dboptions, $dbtty, $dbname);

$cnt = count($itemlist);
if ($type != "edit" && $type != "notes")
{
	if ( $cnt == 0 )
	{
		header("Location: editlist.php?s=$s");
		exit(0);
	}
}

if (isset($sub_delete))
{	
	$stage = 1;
	$text = "Delete Items";
}

if (isset($sub_edit))
{
	$stage = 2;
	$text = "Edit Items";
}

if (isset($sub_notes))
{
	$stage = 3;
	$text = "Edit Item Notes";
}

if (isset($cancel))
{
	header("Location: editlist.php?s=$s");
	exit(0);
}

if ($type == "delete")
{
	$stage = -1;
	$text = "Deleting Items";
}

if ($type == "edit")
{
	$stage = -2;
	$text = "Updating Items";
}

if ($type == "notes")
{
	$stage = -3;
	$text = "Updating Notes";
}

startpage($text, 0);

if ($stage == 1)   // confirmation of deletion
{
	?>
	<h2>Delete Items</h2>
	Please confirm that you wish to delete these items.<p>

	<form method=post action="edit.php?s=<?echo $s?>">
	<input type=hidden name=type value="delete">
	<table><tr><th>Item Description</th><th>Confirm<br>Delete</th></tr>
	<?

	for ($i=0; $i < $cnt; $i++)
	{
		$itnum = $itemlist[$i];
		
		$result = pg_Exec($conn, "SELECT * FROM items WHERE item_num='$itnum'");
		$desc = chop(pg_Result($result, 0, 1));

		?>
		<tr><td><?echo $desc?></td>
			<td><input type=checkbox name=itemlist[] value=<?echo $itnum?> 
				 checked="checked"></td></tr>

		<?
	}
	?>

	<center>
	<tr><td>
		<table><tr>
		<td><input type=submit name=confirm value="Delete items"></td>
		<td width=5%>&nbsp;</td>
		<td><input type=submit name=cancel value="Cancel"></td>
		</tr></table>
	</tr></table>
	
	<?
}

if ($stage == -1)    //deletion
{
	?>
	<h2>Deleting Selected Items</h2>
	<?

	$error = 0;

	for ($i=0; $i < $cnt; $i++)
	{
		$itnum = $itemlist[$i];

		$sql = "SELECT * FROM items WHERE item_num='$itnum' and uid='$uid'";
		$result = pg_Exec($conn, $sql);
		$desc = chop(pg_Result($result, 0, 1));
		$pid = pg_Result($result, 0, 3);

		if ( $pid != -1 )
		{
			notify_purchaser($uid, $itnum, $pid);
		}

		$sql = "DELETE FROM items WHERE item_num='$itnum'";
		$result = pg_Exec($conn, $sql);
		$rows = pg_NumRows($result);

		$sql = "DELETE FROM notes WHERE item_num='$itnum'";
		$result = pg_Exec($conn, $sql);
		$rows = pg_NumRows($result);

		if ($rows != 0)
		{
			$error = 1;
		}
	}

	if ($error != 0)
	{
		?>
		<h2>An error occurred deleting an item. Please try again. If the
		problem persists, contact the registry administrator.</h2>
		<meta HTTP-EQUIV="Refresh" 
			CONTENT="5; URL=./editlist.php?s=<?echo $s?>">
		<?
	}
	else
	{
		?>
		<h2>Your items have been successfully deleted.</h2>
		<meta HTTP-EQUIV="Refresh" 
			CONTENT="3; URL=./editlist.php?s=<?echo $s?>">
		<?
	}
}



if ($stage == 2)   // Editing items
{
	?>
	<h2>Edit Items</h2>
	Please make all your changes to the items below and press submit.<p>

	<form method=post action="edit.php?s=<?echo $s?>">
	<input type=hidden name=type value="edit">
	<input type=hidden name=count value="<?echo $cnt?>">
	<table cellspacing=0 cellpadding=2 border=1>
	<tr><th>Item Description</th><th>Store/URL</th></tr>
	<?

	for ($i=0; $i < $cnt; $i++)
	{
		$itnum = $itemlist[$i];
		
		$result = pg_Exec($conn, "SELECT * FROM items WHERE item_num='$itnum'");
		$desc = chop(pg_Result($result, 0, 1));
		$url = chop(pg_Result($result, 0, 2));

		$indesc = "idesc".$i;
		$inurl = "iurl".$i;
		$inum  = "inum".$i;

		?>
		<tr><td><input type=text name=<?echo $indesc?>
				 size=50 value="<?echo $desc?>"></td>
			<td><input type=text name=<?echo $inurl?>
				 size=60 value="<?echo $url?>"></tr></tr>
			<input type=hidden name=<?echo $inum?>
				value="<?echo $itnum?>">
		<?
	}
	?>
	</tr></td>

	<center>
	<tr><td>
		<table><tr>
		<td><input type=submit name=confirm value="Update items"></td>
		<td width=5%>&nbsp;</td>
		<td><input type=submit name=cancel value="Cancel"></td>
		</tr></table>
	</tr></table>
	
	<?
}

if ($stage == -2)   // updating items
{
	//phpinfo();

	$error = 0;
	
	for ($i = 0; $i < $count; $i++)
	{
		$idesc = "idesc".$i;
		$iurl = "iurl".$i;
		$inum = "inum".$i;

		$desc = $$idesc;
		$url = $$iurl;
		$num = $$inum;

		$sql = "UPDATE items set description='$desc', url='$url' ";
		$sql .= "WHERE item_num='$num'";

		$result = pg_Exec($conn, $sql);
		$rows = pg_NumRows($result);

		if ($rows != 0)
		{
			$error = 1;
		}
	}

	if ($error == 1)
	{
        ?>
        <h2>An error occured updating your item(s). Please try again.</h2
        If the problem persists, please contact the site administrator.
        <meta HTTP-EQUIV="Refresh"
            CONTENT="5; URL=./editlist.php?s=<?echo $s?>">
        <?
	}
	else
	{
	    ?>
    	<h2>Item(s) updated successfuly.</h2>
        <meta HTTP-EQUIV="Refresh"
            CONTENT="3; URL=./editlist.php?s=<?echo $s?>">
		<?
	}
}

if ($stage == 3)
{
	?>
	<h2>Edit Item Notes</h2>
	Please make your changes to the Item Notes below, or select those
	you wish to delete, and press the appropriate button below.<p>

	<form method=post action="edit.php?s=<?echo $s?>">
	<input type=hidden name=type value="notes">
	<input type=hidden name=count value="<?echo $cnt?>">
	<table cellspacing=0 cellpadding=2 border=1>
	<?

	for ($i=0; $i < $cnt; $i++)
	{
		$itnum = $itemlist[$i];

		$sql = "SELECT * FROM items WHERE item_num='$itnum'";
		$result = pg_Exec($conn, $sql);
		$desc = chop(pg_Result($result, 0, 1));

		$sql = "SELECT * FROM notes WHERE item_num='$itnum'";
		$result = pg_Exec($conn, $sql);
		$rows = pg_NumRows($result);

		if ($rows == 1)
		{
			$note = pg_Result($result, 0, 1);
		}
		else
		{
			$note = "";
		}

		$note = chop($note);

		$inum = "inum".$i;
		$inote = "inote".$i;

		?>
		<tr><td><font size=+1><b><?echo $desc?></b></font><br>
				<textarea name="<?echo $inote?>" cols=40 rows=5
				 wrap=physical><?echo $note?></textarea><br>

				Delete: <input type=checkbox name=dellist[] 
				 value="<?echo $itnum?>"><p></td>

			<input type=hidden name="<?echo $inum?>" value="<?echo $itnum?>">
		</tr>
		<?

		if ( $i < ($cnt - 1))
		{
			echo "<tr><td> </td></tr>\n";
			echo "<tr><td> </td></tr>\n";
		}
	}
	?>
	
	</table>

	<table>
	<tr><td>
		<table><tr>
		<td><input type=submit name=upd_note value="Update Notes">
		<td width=5%>&nbsp;</td>
		<td><input type=submit name=cancel value="Cancel"></td>
		</tr></table>
	</tr></table>

	<?
}

if ($stage == -3)
{
	$error = 0;
	$error2 = 0;

	for ($i = 0; $i < $count; $i++)
	{
		$inote = "inote".$i;
		$inum = "inum".$i;

		$note = $$inote;
		$num = $$inum;

		$note = chop($note);

		if ($note != "")
		{
			$sql = "DELETE FROM notes where item_num='$num'";
			$result = pg_Exec($conn, $sql);
	
			$sql = "INSERT INTO notes VALUES('$num', '$note')";
	
			$result = pg_Exec($conn, $sql);
			$rows = pg_NumRows($result);
	
			if ($rows != 0)
			{
				$error = 1;
			}
		}
	}

	if (isset($dellist))
	{
		$count2 = count($dellist);
		for ($i = 0; $i < $count2; $i++)
		{
			$itnum = chop($dellist[$i]);
			$sql = "DELETE FROM notes WHERE item_num='$itnum'";

			$result = pg_Exec($conn, $sql);
			$rows = pg_NumRows($result);

			if ($rows != 0)
			{
				$error2 = 1;
			}
		}
	}

	if ($error == 1 || $error2 == 1)
	{
		?>
		<h2>An error occured updating your item note(s). Please try again.</h2>
		If the problem persistes, please contact the site administrator.
		<meta HTTP-EQUIV="Refresh"
			"CONTENT="5; URL=./editlist.php?s=<?echo $s?>">
		<?
	}
	else
	{
		?>
		<h2>Item Note(s) updated.</h2>
		<meta HTTP-EQUIV="Refresh"
			"CONTENT="3; URL=./editlist.php?s=<?echo $s?>">
		<?
	}
}
		


endpage(0);
?>
