<?
//
// GiftWeb: PHP/PostgreSQL online Gift Registry System 
// Matthew T. Jachimstal
// Copyright (C) 2000  Matthew T. Jachimstal
//
// email: matthew@jachimstal.com
//
// Snail mail: Matthew Jachimstal
//             337 Chesterfield Lane, #205
//             Maumee, OH 43537
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
require "./main.inc";
require "./util.php";

$uid = validatesession($s);

$step = 1;		// step 1 = display group membership and requests
$conn = pg_connect($dbhost, $dbport, $dboptions, $dbtty, $dbname);

$result1 = pg_Exec($conn, "SELECT * FROM groups WHERE admin='$uid'");
$rows1 = pg_NumRows($result1);

if ($rows1 == 0)
{
	startpage("Error: Not Administrator", 0);
	?>
	<h2>Error: You are not a group administrator</h2>
	<meta HTTP-EQUIV="Refresh" CONTENT="3; URL=./main.php?s=<?echo $s?>">
	<?
	endpage(-1);
	exit();
}
	

startpage("Group Administration", 0);

if ( isset($submit))
{
	$step = 2;  // process the data
}

if ( $step == 2 )
{
	$cntdel = count($userdel);
	$cntapp = count($approve);
	$cntdeny = count($deny);

	// setup an associative array (by uid) of requests to deny
	$deny_check[0]=0;

	for ( $i=0; $i < $cntdeny; $i++ )
	{
		$deny_check[$deny[$i]] = 1;
	}

	// if they're in the $approve array, set the deny_check[uid] to 0
	for ( $i=0; $i < $cntapp; $i++ )
	{
		$deny_check[$approve[$i]] = 0;
	}

	// delete users
	$del_err = 0;

	for ( $i=0; $i < $cntdel; $i++ )
	{
		$sql = "DELETE FROM members WHERE uid='$userdel[$i]'";
		$sql .= " and gid='$group'";
		$result = pg_Exec($conn, $sql);

		/*
		 * FIX
		 * check for deletion error
		 * mail to user that they've been removed
		 */
	}

	if ($del_err == 1)
	{
		/* 
		 * FIX
		 * display error 
		 */
	}

	// approve requests
	$app_err = 0;

	for ( $i=0; $i < $cntapp; $i++ )
	{
		$sql = "UPDATE members SET request = 'f' WHERE";
		$sql .= " uid='$approve[$i]' and gid='$group'";
		$result = pg_Exec($conn, $sql);

		/* 
		 * FIX
		 * check for error 
		 * mail to user that they've been approved 
		 */
	}

	if ($app_err == 1)
	{
		/*
		 * FIX 
		 * display error
		 */
	}

	// deny requests, only if the check_deny value for that uid is 1
	$deny_err = 0;

	for ( $i=0; $i < $cntdeny; $i++ )
	{
		if ( $deny_check[$deny[$i]] == 1 )
		{
			$sql = "DELETE FROM members WHERE uid='$deny[$i]'";
			$sql .= " and gid='$group'";
			$result = pg_Exec($conn, $sql);

			/* 
			 * FIX
			 * check for error
			 * mail user that they've been denied
			 */
		}
	}

	if ( $deny_error == 1)
	{
		/* 
		 * FIX
		 * display error
		 */
	}

	$step = 1;
}


if ( $step == 1 )
{
	// foreach group this user is the administrator for
	for($i=0; $i<$rows1; $i++)
	{
		$gid = pg_Result($result1, $i, 0);
		$group = chop(pg_Result($result1, $i, 1));
		?>
		<h2>Group: <?echo $group?></h2>
		<table><tr><td width=10%></td>
		<td><h3>Members:</h3></td></tr></table>

		<form method="post" action="grpadm.php?s=<?echo $s?>">
		<input type="hidden" name=group value="<?echo $gid?>">

		<table>
		<tr><th width=5%></th>
			<th width=25% align=left>Name</th>
			<th width=5%></th>
			<th align=left>Delete User<th></tr>
		<?
	
		$sql = "SELECT * FROM members where gid='$gid' and request='f'";
		$sql .= " ORDER BY uid";
		$result2 = pg_Exec($conn, $sql);
		$rows2 = pg_NumRows($result2);
	
		if ( $rows2 == 0 )
		{
			echo "<tr></tr>\n";
		}
	
		// foreach user that is a member (approved) of this group
		for ($j=0; $j < $rows2; $j++)
		{
			$user = pg_Result($result2, $j, 1);
			$result3 = pg_Exec($conn, "SELECT * FROM users where
					uid='$user'");
			$name = chop(pg_Result($result3, 0, 1));
	
			?>
			<tr><td></td>
				<td><?echo $name?></td>
				<td></td>
				<td><input type=checkbox name="userdel[]"
					value="<?echo $user?>"></td></tr>
			<?
		}
		?>
		</table>
		<hr align=center width=70% size=5>

		<?
	
		$sql = "SELECT * FROM members where gid='$gid' and request='t'";
		$sql .= " ORDER BY uid";
		$result2 = pg_Exec($conn, $sql);
		$rows2 = pg_NumRows($result2);

		if ( $rows2 > 0 )
		{
			?>
			<table><tr><td width=10%></td>
				<td><h3>Requests to be added:</h3></td></tr></table>

				<table cellspacing=0 cellpadding=5>
				<tr><th width=10%></th>
				<th>Name</th>
				<th>Approve</th>
				<th>Deny</th></tr>
			<?
		}
	
		// foreach user requesting to be a member of this group
		for ($j=0; $j < $rows2; $j++)
		{
			$user = pg_Result($result2, $j, 1);
			$result3 = pg_Exec($conn, "SELECT * FROM users where
					uid='$user'");
			$name = chop(pg_Result($result3, 0, 1));
	
			?>
			<tr><td></td>
				<td><?echo $name?></td>
				<td><input type=checkbox name="approve[]"
					value="<?echo $user?>"></td>
				<td><input type=checkbox name="deny[]"
					value="<?echo $user?>"></td></tr>
			<?
		}

		if ( $rows2 > 0 )
		{
			echo "</table>\n";
		}

		?>

		<p>
		<input type=submit name=submit value="Update Group">
		<input type=reset value="Clear changes"><p>

		<?
		if ( $rows2 > 0 )
		{
			echo "(If both approve and deny are selected for a user, ";
			echo "they will be approved.)";
		}
		?>

		</form>
		<hr size=10>
		<?
	}
	
	endpage(0);
}
?>
