<?
//
// GiftWeb: PHP/PostgreSQL online Gift Registry System 
// Matthew T. Jachimstal
// Copyright (C) 2000  Matthew T. Jachimstal
//
// email: matthew@jachimstal.com
//
// Snail mail: Matthew Jachimstal
//             337 Chesterfield Lane, #205
//             Maumee, OH 43537
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//

require "./main.inc";
// passed $s=session#, $u=target user id
require "./util.php";

$uid = validatesession($s);

$conn = pg_connect($dbhost, $dbport, $dboptions, $dbtty, $dbname);


cleanup_items();

$step = 0;

if ( isset($submit1) )		// adding items not on list
{
	$step = 1;
}

if ( isset($purch) )		// marking items purchased
{
	$step = 2;
}

if ( isset($unpurch) )		// marking items unpurchased
{
	$step = 3;
}

//need to do steps 2 and 3

if ($step == 1)		// add purchased items not on the wishlist
{
	$sql = "SELECT count(*), max(item_num) FROM items";
	$result = pg_Exec($conn, $sql);
	$rows = pg_Result($result, 0, 0);
	$max_item = pg_Result($result, 0, 1);

	if ($rows == 0)
	{
		$max_item = 1;
	}
	else
	{
		$max_item++;
	}

	$rows = 0;		// set for error checking later

	for ($i=1; $i <= 10; $i++)
	{
		$desc = "idesc$i";
		$item = chop ($$desc);

		if ( $item != "" )
		{
			$sql = "INSERT INTO items VALUES ('$u', '$item', '', ";
			$sql .= "'$uid', 't', '$max_item')";
			$result = pg_Exec($conn, $sql);
			$rows += pg_NumRows($result);
			$max_item++;
		}
	}

	if ($rows != 0)
	{
		$res1 = "<h2>An error occured adding an item. Please try again.<br>";
		$res1 .= "If the problem persists, please contact the site ";
		$res1 .= "administrator.</h2>\n";
	}
	else
	{
		$res1 = "<h2>Item(s) added.</h2>\n";
	}


	$step = 0;
}

// steps 2 and 3 do error checking as follows:
// the itemlist[] array potentially contains purchased and unpurchased
// items. Each step (purch/unpurch) filters the UPDATE or DELETE
// SQL statement by the current purchased value. 
//
// If it's marking items as purchased by the current user, it only UPDATEs 
// those items whose purchased field is -1. This prevents them from trying
// to remark items they've already purchased, although that would have
// no net effect. It's just the easiest way to error check this condition.
// It also prevents them from somehow hijacking items that were already
// marked purchased by a third user. This could possibly happen from someone
// writing their own page whose form action POSTs to this php page. 
// This is also a concurrency issue. If two people load the page and one 
// submits a purchase and the second doesn't refresh before submitting 
// the same purchase. The second user will not be able to update, because
// it will only update WHERE purchased=-1. They will reload the page after
// submission, and see that the item's already been marked by someone
// else. Potential cause for UTS and ID-10-T errors.
//
// When unpurchasing, the current value of purchased must be the user's
// uid. If it is -1, they're trying to unpurchased and item that hasn't been
// marked purchased. If it's another uid, they somehow got and invalid
// form that presented them with items they hadn't purchased. This is the
// the last error check to prevent that. Again, that could conceivably
// be caused by a malicious form POSTing to this script.

if ( $step == 2 )	// marking items as purchased
{
	$cnt = count ($itemlist);

	$marked = 0;

	for ( $i=0; $i<$cnt; $i++ )
	{
		// update the purchased field to this user's $uid only if
		// item is not purchased 

		$sql = "UPDATE items SET purchased='$uid'";
		$sql .= " WHERE item_num='$itemlist[$i]' and purchased='-1'";

		$result = pg_Exec($conn, $sql);

		/*
		 * FIX
		 * check for error conditions (are any possible?)
		 * keep count of how many are marked
		 */
	}

	$step = 0;
}

if ( $step == 3 )	// marking items as unpurchased
{
	$cnt = count($itemlist);
	$unmarked = 0;
	$removed = 0;

	for ( $i=0; $i<$cnt; $i++ )
	{
		// unmarking has to conditions: item added by requestor
		// and item added by purchaser. 
		// In both cases we set the purchaser to -1.
		// Then, we look for any rows with purchaser=-1 and added=t
		// Those are unpurchased items that were added by the purchaser
		// and need to be deleted.
		// Also, we need to make that purchaser=uid, so we don't hijack
		// anyone else's purchases.

		$sql = "UPDATE items SET purchased='-1'";
		$sql .= " WHERE item_num='$itemlist[$i]' and purchased='$uid'";

		$result = pg_Exec($conn, $sql);

		/*
		 * FIX
		 * check for error condition (are any possible?)
		 * count how many are unmarked
		 */
	}

	$sql = "DELETE FROM items WHERE purchased='-1' and added='t'";

	$result = pg_Exec($conn, $sql);

	/*
	 * FIX
	 * count how many were deleted
	 */

	$step = 0;
}



if ($step == 0)		// display list/purch/unpurch/add to list
{
	$result = pg_Exec($conn, "SELECT name FROM users WHERE uid='$u'");
	$name = chop(pg_Result($result, 0, 0));

	startpage("$name's Wishlist", 0);

	if ( isset($res1))
	{
		echo $res1;
	}

	?>
	<h2><?echo $name?>'s wishlist:</h2>

	<form method="post" action="viewlist2.php?s=<?echo $s?>&u=<?echo $u?>">
	<table cellspacing=0 cellpadding=1 border=1>
	<?

	$sql = "SELECT * FROM items WHERE uid='$u' ";
	$sql .= "and purchased='$uid' ORDER BY item_num";
	$result = pg_Exec($conn, $sql);
	$rows = pg_NumRows($result);

	echo "<tr><th width=35%>Description</th>";
	echo "<th width=35%>Store/URL</th>";
	echo "<th width=15%>Notes</th>";
	echo "<th width=15%>Select</th></tr>\n";

	for ($i=0; $i < $rows; $i++)
	{
		$desc = pg_Result($result, $i, 1);
		$url = chop(pg_Result($result, $i, 2));
		$item_num = pg_Result($result, $i, 5);
		$purchased = pg_Result($result, $i, 3);
		$added = pg_Result($result, $i, 4);

		if ( substr($url, 0, 7) == "http://" )
		{
			$www = substr($url, 7);
			$url = "<a href=\"$url\" target=\"_new\">$www</a>";
		}

		echo "<tr><td>$desc</td>";
		echo "<td>$url&nbsp;</td>";

		$sql = "SELECT * FROM notes WHERE item_num='$item_num'";
		$result2 = pg_Exec($conn, $sql);
		$rows2 = pg_NumRows($result2);

		if ($rows2 > 0)
		{
			$note_text = "<a href=\"viewnote.php?s=$s&i=$item_num\" ";
			$note_text .= "target=\"_new\">";
			$note_text .= "View Notes</a>";
		}
		else
		{
			$note_text = "&nbsp;";
		}

		if ( $added == 't' )
		{
			$note_text = "Item Added<br>by Purchaser";
		}

		$sel_text = "Purchased<br>";

		$sel_text .= "<input type=checkbox name=\"itemlist[]\" ";
		$sel_text .= "value=\"$item_num\">";

		?>

			<td align=center>
			<?echo $note_text?>
			<td align=center><?echo $sel_text?></td>
			</tr>
			<?
	}

	$sql = "SELECT * FROM items WHERE uid='$u' ";
	$sql .= "and purchased !='$uid' ORDER BY purchased desc, item_num";
	$result = pg_Exec($conn, $sql);
	$rows = pg_NumRows($result);

	for ($i=0; $i < $rows; $i++)
	{
		$desc = pg_Result($result, $i, 1);
		$url = chop(pg_Result($result, $i, 2));
		$item_num = pg_Result($result, $i, 5);
		$purchased = pg_Result($result, $i, 3);
		$added = pg_Result($result, $i, 4);

		if ( substr($url, 0, 7) == "http://" )
		{
			$www = substr($url, 7);
			$url = "<a href=\"$url\" target=\"_new\">$www</a>";
		}

		echo "<tr><td>$desc</td> <td>$url&nbsp;</td>";

		$sql = "SELECT * FROM notes WHERE item_num='$item_num'";
		$result2 = pg_Exec($conn, $sql);
		$rows2 = pg_NumRows($result2);

		if ($rows2 > 0)
		{
			$note_text = "<a href=\"viewnote.php?s=$s&i=$item_num\" ";
			$note_text .= "target=\"_new\">";
			$note_text .= "View Notes</a>";
		}
		else
		{
			$note_text = "&nbsp;";
		}

		if ( $added == 't' )
		{
			$note_text = "Item Added<br>by Purchaser";
		}

		$sel_text = "&nbsp;";

		if ($purchased == -1)
		{
			$sel_text = "<input type=checkbox name=\"itemlist[]\" ";
			$sel_text .= "value=\"$item_num\">";
		}
		else
		{
			$sel_text = "Purchased by another user";
		}

		?>

			<td align=center>
			<?echo $note_text?>
			<td align=center><?echo $sel_text?></td>
			</tr>
			<?
	}
	?>
		</table>
		<br>

		<input type=submit name="purch" value="Purchase Selected Items">
		<input type=submit name="unpurch" value="Un-purchase Selected Items">
		<input type=reset name=reset value="Clear Selections">
		</form>

		<?

		// add a section where users can add items they've purchased
		// that aren't on the list

		?>
		<p>
		<hr width=70% size=5
		<h4>If you've purchased items not on <?echo $name?>'s list,
	please add them below. They will be displayed to other users to see
		that they've been purchased. <?echo $name?> will not see these
		items and will not be able to delete them.</h4>
		<form method="post" action="viewlist2.php?s=<?echo $s?>&u=<?echo $u?>">
		<table cellspacing=0 cellpadding=2>
		<tr><td></td><td align=center>Description</td></tr>
		<tr><td>1</td><td><input type="text" name="idesc1" size=50></td></tr>
		<tr><td>2</td><td><input type="text" name="idesc2" size=50></td></tr>
		<tr><td>3</td><td><input type="text" name="idesc3" size=50></td></tr>
		<tr><td>4</td><td><input type="text" name="idesc4" size=50></td></tr>
		<tr><td>5</td><td><input type="text" name="idesc5" size=50></td></tr>
		<tr><td>6</td><td><input type="text" name="idesc6" size=50></td></tr>
		<tr><td>7</td><td><input type="text" name="idesc7" size=50></td></tr>
		<tr><td>8</td><td><input type="text" name="idesc8" size=50></td></tr>
		<tr><td>9</td><td><input type="text" name="idesc9" size=50></td></tr>
		<tr><td>10</td><td><input type="text" name="idesc10" size=50></td></tr>
		<tr><td></td><td align=center><input type="submit" name="submit1" 
		value="Add item(s)">
		<input type="reset" name="reset" value="Clear"></tr></tr>
		</table>
		</form>
		<?

}

//phpinfo();
endpage(0);
?>
